/***************************************************/
/*                                                 */
/*   Rainpack - version 1.0 - 31 janvier 2012      */
/*                                                 */
/*   Author: Bruno Godefroy alias Nitrosax         */
/*                                                 */
/*   Thanks to PierrotLL for his functions         */
/*                                                 */
/*   nitrosax@laposte.net                          */
/*                                                 */
/***************************************************/

#include "fxlib.h"
#include "perso.h"
#include "functions.h"
#include "engine.h"
#include "menu.h"

#define SPEED 5

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int last_score = 0;
	char i, j;
	
	random(time_getTicks(), 5);
	
	while(1)
	{
		int time = 0;
		unsigned int compteur_ciel = 0;
		personnage perso;
		Ciel ciel;
		Choix choix;
		
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 7; j++)
				ciel.air[i][j] = RIEN;
		}
		
		ciel.scrolling = 0;
		ciel.indice[0] = 0;
		ciel.indice[1] = 0;
		
		perso = init_perso(perso);
	
		choix = menu(last_score / 4);
		if(choix == QUIT) return 1;
		last_score = 0;

		do
		{
			ML_clear_vram();
			
			while(time_getTicks() - time < SPEED) // boucle d'attente
			{}
			time = time_getTicks();
			
			ciel.scrolling++;
			
			ciel = remplissage_ciel(ciel, perso);
			perso = move_perso(perso);
			
			if(perso.hauteur > last_score)
				last_score = perso.hauteur;
			
			if(perso.direction == UP && perso.chute < 20)
				ciel.scrolling++;
			if(perso.direction == DOWN || (perso.chute > 20 && perso.hauteur > 0))
				ciel.scrolling -= 6;
			
			affiche_ciel(ciel);
			perso = detecte_collision(perso, &ciel);
			ciel = affiche_explosion(ciel);
			affiche_perso(perso);
			affiche_barre(perso);
			
			ML_display_vram();

			if(key_down(K_MENU))
				return;
		}
		while(!(perso.hauteur <= 0 && (perso.chute > 20 || perso.fuel == 0)));
		
		game_over(perso.position);
		ML_clear_vram();
	}
	
    return 1;
}



//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

