#include "functions.h"
#include "MonochromeLib.h"

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)( int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

int time_getTicks() // Function from PierrotLL
{
	return (*SysCall)(0, 0, 0, 0, 0x3B);
}

static void delay()
{
	unsigned char i;
	for(i=0 ; i<5 ; i++);
}

unsigned char key_down(unsigned char code) { // Function from PierrotLL
	int result=0;
	short*PORTB_CTRL=(void*)0xA4000102;
	short*PORTM_CTRL=(void*)0xA4000118;
	char*PORTB=(void*)0xA4000122;
	char*PORTM=(void*)0xA4000138;
	char*PORTA=(void*)0xA4000120;
	short smask;
	char cmask;
	unsigned char column, row;

	column = code>>4;
	row = code &0x0F;

	smask = 0x0003 << (( row %8)*2);
	cmask = ~( 1 << ( row %8) );
	if ( row <8)
	{
		// configure port B as input, except for the "row to check"-bit, which has to be an output.
		*PORTB_CTRL = 0xAAAA ^ smask;
		// configure port M as input; port M is inactive with row < 8
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
		delay();
		*PORTB = cmask;    // set the "row to check"-bit to 0 on port B
		*PORTM = (*PORTM & 0xF0 ) | 0x0F;    // port M is inactive with row < 8
	}
	else
	{
		*PORTB_CTRL = 0xAAAA;  // configure port B as input; port B is inactive with row >= 8
		// configure port M as input, except for the "row to check"-bit, which has to be an output.
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
		delay();
		*PORTB = 0xFF;    // port B is inactive with row >= 8 (all to 1)
		*PORTM = (*PORTM & 0xF0 ) | cmask;  // set the "row to check"-bit to 0
	};
	delay();
	result = (~(*PORTA))>>column&1;   // a pressed key in the row-to-check draws the corresponding bit to 0
	delay();
	*PORTB_CTRL = 0xAAAA;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
	delay();
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
	delay();
  return result;
}

unsigned int random(int seed, int value) { // Function from SimLo
    static unsigned int lastrandom = 0x12345678;
    if(seed) lastrandom = seed;
    lastrandom = (0x41C64E6D * lastrandom) + 0x3039;
    return ((lastrandom >> 16) % value);
}

void printVmini(int x, int y, int m)
{
	int i, lenght = 0;
	char str[12] = "0";
	
	if(m)
	{
		if(m < 0)
		{
			lenght ++;
			str[0] = '-';
			m = - m;
		}
		
		for(i=m; i; i/=10) lenght++ ;
		str[lenght] = 0;
		for( ; m; m/=10) str[--lenght] = m%10 + '0';
	}
	
	PrintMini(x,y, str, 0);
}

void displayVram() {
	ML_display_vram();
	ML_clear_vram();
}

void test(int i) {
	printVmini(1, 10, i);
	displayVram();
	Sleep(500);
}

int nbFigures(int number) {
	unsigned char i = 1;
	for(i = 1; i < 10; i++) {
		if(number % puissance10(i) == number)
			break;
	}
	return i;
}

static unsigned int puissance10(int puissance) {
	int i, value = 10;
	for(i = 1; i < puissance; i++)
		value *= 10;
	return value;
}